VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Submission"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'    Object: Mailer.Submission
'   Purpose: Provide facility to send SMTP mail asyncronously from ASP
'   Version: 1.0.0
' Author(s): Luke Bailey, for Pinnacle Publishing - Active Web Developer

' History
' v1.0.0 - 05/01/2002 - First implementation
'        - 31/01/2002 - Release

Private xmldoc As MSXML2.DOMDocument30
Private root As MSXML2.IXMLDOMElement
Private routing As MSXML2.IXMLDOMElement
Private message As MSXML2.IXMLDOMElement
Private attachments As MSXML2.IXMLDOMElement
Private fromset As Boolean
Private subset As Boolean
Private bodyset As Boolean
Private rcount As Integer

'Initialise/Finalise

Public Sub Initialise()
 'Build initial structure for XML document and retain pointers to child elements
 Set xmldoc = New MSXML2.DOMDocument30
 xmldoc.loadXML "<SMTPMailer-1.0></SMTPMailer-1.0>"
 Set root = xmldoc.documentElement
 Set routing = xmldoc.createElement("Routing")
 Set message = xmldoc.createElement("Message")
 Set attachments = xmldoc.createElement("Attachments")
 root.appendChild routing
 root.appendChild message
 root.appendChild attachments
 'Misc stuff
 fromset = False
 rcount = 0
End Sub

Public Sub Finalise()
 'Release global objects
 Set attachments = Nothing
 Set message = Nothing
 Set routing = Nothing
 Set root = Nothing
 Set xmldoc = Nothing
End Sub

'Routing element

Public Sub SetFrom(ByVal address As Variant, ByVal fullname As Variant)
 If Not fromset Then
  Dim s As MSXML2.IXMLDOMElement
  Dim t As MSXML2.IXMLDOMElement
  Set s = xmldoc.createElement("FROM")
  Set t = xmldoc.createElement("FROM-NAME")
  s.Text = CStr(address)
  t.Text = CStr(fullname)
  routing.appendChild s
  routing.appendChild t
  Set s = Nothing
  Set t = Nothing
 Else
  xmldoc.getElementsByTagName("FROM").Item(0).Text = CStr(address)
  xmldoc.getElementsByTagName("FROM-NAME").Item(0).Text = CStr(fullname)
 End If
End Sub

Public Sub AddRecipient(ByVal recipient As Variant)
 Dim s As MSXML2.IXMLDOMElement
 Set s = xmldoc.createElement("TO")
 s.Text = CStr(recipient)
 routing.appendChild s
 Set s = Nothing
 rcount = rcount + 1
End Sub

'Message element

Public Sub SetBody(ByVal body As Variant)
 If Not subset Then
  Dim s As MSXML2.IXMLDOMElement
  Set s = xmldoc.createElement("BODY")
  s.Text = CStr(body)
  message.appendChild s
  Set s = Nothing
 Else
  xmldoc.getElementsByTagName("BODY").Item(0).Text = CStr(body)
 End If
End Sub

Public Sub SetSubject(ByVal subject As Variant)
 If Not bodyset Then
  Dim s As MSXML2.IXMLDOMElement
  Set s = xmldoc.createElement("SUBJECT")
  s.Text = CStr(subject)
  message.appendChild s
  Set s = Nothing
 Else
  xmldoc.getElementsByTagName("SUBJECT").Item(0).Text = CStr(subject)
 End If
End Sub

'Attachment element

Public Sub AddAttachment(ByVal path As Variant)
 Dim s As MSXML2.IXMLDOMElement
 Set s = xmldoc.createElement("FILE")
 s.Text = CStr(path)
 attachments.appendChild s
 Set s = Nothing
End Sub

'MSMQ Send

Public Function Send(MSMQName As Variant) As Variant
  
  'On Error GoTo er_send
  Send = "ERR"
  
  'Check everything is set
  If rcount < 1 Then
   Send = "ERR - No recipients specified."
  Else
   If Not fromset Then
    Send = "ERR - No from name or address specified."
   Else
    If Not subset Then
     Send = "ERR - No subject set for message."
    Else
     If Not bodyset Then
      Send = "ERR - No message set!"
     Else
      'send message
     End If
    End If
   End If
  End If
  
  'Open message queue
  Dim queueinfo As MSMQQueueInfo
  Set queueinfo = New MSMQQueueInfo
  queueinfo.PathName = CStr(MSMQName)
  Dim queue As MSMQQueue
  Set queue = queueinfo.Open(MQ_SEND_ACCESS, MQ_DENY_NONE)
 
  'Dispatch message
  Dim msg As MSMQMessage
  Set msg = New MSMQMessage
  msg.Label = "SMTPMailer-Inbound"
  msg.body = xmldoc.xml
  msg.Priority = MQ_MAX_PRIORITY
  msg.Send queue
  queue.Close
 
  'clean up
  Set msg = Nothing
  Set queue = Nothing
  Set queueinfo = Nothing
  Send = "OK"
  Exit Function
  
er_send:
  On Error Resume Next
  Send = "ERR - Internal error sending message to MSMQ"
  Set msg = Nothing
  Set queue = Nothing
  Set queueinfo = Nothing
  App.LogEvent "Mailer.Submision [COM]:Error submitting message to MSMQ.", 1

End Function



